waxClass{"TwitterViewController", UITableViewController}

function init(self)
	self.super:initWithStyle(UITableViewStyleGrouped)
	self.trends = {}
	
	return self
end

function viewDidLoad(self)
	self:setTitle("My First Wax Application")
	self:tableView():setAllowsSelection(false)

	local button = UIBarButtonItem:initWithBarButtonSystemItem_target_action(UIBarButtonSystemItemRefresh, self, "loadDataFromTwitter")
	self:navigationItem():setRightBarButtonItem(button)
	
	self:loadDataFromTwitter()
end

function loadDataFromTwitter(self)
	UIApplication:sharedApplication():setNetworkActivityIndicatorVisible(true) -- show spinner
	wax.http.request{"http://api.twitter.com/1/trends.json", callback = function(json, response)
		UIApplication:sharedApplication():setNetworkActivityIndicatorVisible(false) -- hide spinner
		if response:statusCode() == 200 then
			self.trends = {} -- Reset the list of trends when the trends are refreshed
			for index,value in ipairs(json["trends"]) do -- iterate over a table with numerical keys
				table.insert(self.trends, value["name"]) -- append the value to the "array"
			end
		end
		self:tableView():reloadData()
	end}
end

-- DataSource
-------------
function numberOfSectionsInTableView(self, tableView)
	return 1
end

function tableView_numberOfRowsInSection(self, tableView, section)
	return #self.trends
end

function tableView_titleForHeaderInSection(self, tableView, section)
	if section == 0 then
		return "Currently Trending Topics"
	end
	
	return nil
end

function tableView_cellForRowAtIndexPath(self, tableView, indexPath)	
	local identifier = "TwitterTableViewControllerCell"
	local cell = tableView:dequeueReusableCellWithIdentifier(identifier) or
							 UITableViewCell:initWithStyle_reuseIdentifier(UITableViewCellStyleDefault, identifier)	

	local object = self.trends[indexPath:row() + 1] -- Must +1 because lua arrays are 1 based
	cell:textLabel():setText(object)

	return cell
end